<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Factory;

use Dedi\SyliusVoucherPlugin\Model\VoucherInterface;
use Sylius\Component\Core\Model\ChannelInterface;
use Sylius\Component\Core\Model\OrderItemUnitInterface;
use Sylius\Component\Resource\Factory\FactoryInterface;

interface VoucherFactoryInterface extends FactoryInterface
{
    public function createNew(): VoucherInterface;

    public function createForChannel(ChannelInterface $channel): VoucherInterface;

    public function createFromOrderItemUnit(OrderItemUnitInterface $orderItemUnit): VoucherInterface;
}
