<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Menu;

use Dedi\Contracts\SyliusPluginSettings\SettingsProviderInterface;
use Knp\Menu\ItemInterface;
use Sylius\Bundle\UiBundle\Menu\Event\MenuBuilderEvent;

final class AccountMenuListener
{
    public function __construct(
        private readonly SettingsProviderInterface $settingsProvider,
    ) {
    }

    public function addAccountMenuItems(MenuBuilderEvent $event): void
    {
        if (!$this->settingsProvider->provide()->isEnabled()) {
            return;
        }

        $menu = $event->getMenu();

        $this->addVouchersMenu($menu);
    }

    private function addVouchersMenu(ItemInterface $menu): void
    {
        $menu->addChild('vouchers', ['route' => 'dedi_sylius_voucher_shop_voucher_index'])
            ->setLabel('dedi_sylius_voucher.ui.vouchers')
            ->setLabelAttribute('icon', 'gift')
        ;
    }
}
